commit 5900b4032e9b75b6d0a3340ee00590acc9a610b9
Author: freddy77 <freddy77>
Date:   Mon Jul 14 08:14:47 2008 +0000

    minor SQLWCHAR improves

diff --git a/ChangeLog b/ChangeLog
index 269213e..29f3fd6 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Jul 14 10:14:29 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/prepare_query.c src/odbc/sql2tds.c:
+	- minor SQLWCHAR improves
+
 Fri Jul 11 11:25:28 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/data.c src/odbc/unittests/genparams.c:
 	- make some tests run even on mssql2005
@@ -424,4 +428,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2553 2008/07/11 09:29:17 freddy77 Exp $
+$Id: ChangeLog,v 1.2554 2008/07/14 08:14:47 freddy77 Exp $
diff --git a/src/odbc/prepare_query.c b/src/odbc/prepare_query.c
index 2904569..48a071d 100644
--- a/src/odbc/prepare_query.c
+++ b/src/odbc/prepare_query.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: prepare_query.c,v 1.66 2008/07/07 11:09:43 freddy77 Exp $");
+TDS_RCSID(var, "$Id: prepare_query.c,v 1.67 2008/07/14 08:14:48 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -245,6 +245,7 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 	int need_bytes;
 	TDSCOLUMN *curcol;
 	TDSBLOB *blob;
+	int sql_src_type;
 
 	if (!stmt->params) {
 		tdsdump_log(TDS_DBG_FUNC, "error? continue_parse_prepared_query: no parameters provided");
@@ -274,10 +275,17 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 		}
 	}		
 
+	/* get C type */
+	sql_src_type = drec_apd->sql_desc_concise_type;
+	if (sql_src_type == SQL_C_DEFAULT)
+		sql_src_type = odbc_sql_to_c_type_default(drec_ipd->sql_desc_concise_type);
+
 	switch(StrLen_or_Ind) {
 	case SQL_NTS:
-		/* TODO WCHAR */
-		len = strlen((char *) DataPtr);
+		if (sql_src_type == SQL_C_WCHAR)
+			len = sqlwcslen((SQLWCHAR *) DataPtr);
+		else
+			len = strlen((char *) DataPtr);
 		break;
 	case SQL_NULL_DATA:
 		len = 0;
@@ -306,24 +314,18 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 	/* copy to destination */
 	if (blob) {
 		TDS_CHAR *p;
-		int dest_type, src_type, sql_src_type, res;
+		int dest_type, src_type, res;
 		CONV_RESULT ores;
 		TDS_DBC * dbc = stmt->dbc;
 		void *free_ptr = NULL;
 		int start = 0;
 		SQLPOINTER extradata = NULL;
 		SQLLEN extralen = 0;
-		
 
 		if (0 == (dest_type = odbc_sql_to_server_type(dbc->tds_socket, drec_ipd->sql_desc_concise_type))) {
 			odbc_errs_add(&dbc->errs, "07006", NULL); /* Restricted data type attribute violation */
 			return SQL_ERROR;
 		}
-			
-		/* get C type */
-		sql_src_type = drec_apd->sql_desc_concise_type;
-		if (sql_src_type == SQL_C_DEFAULT)
-			sql_src_type = odbc_sql_to_c_type_default(drec_ipd->sql_desc_concise_type);
 
 		/* test source type */
 		/* TODO test intervals */
@@ -332,7 +334,7 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 			odbc_errs_add(&stmt->dbc->errs, "07006", NULL); /* Restricted data type attribute violation */
 			return SQL_ERROR;
 		}
-		
+
 		if (sql_src_type == SQL_C_CHAR) {
 			switch (tds_get_conversion_type(curcol->column_type, curcol->column_size)) {
 			case SYBBINARY:
diff --git a/src/odbc/sql2tds.c b/src/odbc/sql2tds.c
index 449850d..6b217de 100644
--- a/src/odbc/sql2tds.c
+++ b/src/odbc/sql2tds.c
@@ -52,7 +52,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sql2tds.c,v 1.66 2008/07/07 11:27:12 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sql2tds.c,v 1.67 2008/07/14 08:14:48 freddy77 Exp $");
 
 static TDS_INT
 convert_datetime2server(int bindtype, const void *src, TDS_DATETIME * dt)
@@ -331,6 +331,9 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 	case SYBVARCHAR:
 	case XSYBCHAR:
 	case XSYBVARCHAR:
+	case XSYBNVARCHAR:
+	case XSYBNCHAR:
+	case SYBNVARCHAR:
 		ores.cc.c = (TDS_CHAR*) dest;
 		ores.cc.len = curcol->column_size;
 		res = tds_convert(dbc->env->tds_ctx, src_type, src, len, TDS_CONVERT_CHAR, &ores);
@@ -385,9 +388,6 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 		res = tds_convert(dbc->env->tds_ctx, src_type, src, len, dest_type, (CONV_RESULT*) dest);
 		break;
 	default:
-	case XSYBNVARCHAR:
-	case XSYBNCHAR:
-	case SYBNVARCHAR:
 	case SYBNTEXT:
 	case SYBVOID:
 	case SYBVARIANT:

